# Pull Request guidelines

## Before submitting a pull request, please make sure you have done the following: 

1. `Fork` the repository and create your branch from master. 
2. If you have added code or fixed a bug please make sure to write tests to test it
   or if tests were already written for this new feature, make sure that tests pass. 
3. You can compile the test using `make test`. Make sure it compiles successfully, 
   then run the tests that was compiled in ./bin/test and make sure no tests fail.
4. Make sure you followed the coding conventions listed in [conventions.md](docs/conventions.md)
5. Make sure you run `make beautiful` to fix any style or indentation problem you may have.


## Pull Request Template: 


## Purpose
_Describe the problem or feature in addition to a link to the issues._

## Approach
_How does this change address the problem?_

#### Open Questions and Pre-Merge TODOs
- [ ] Use github checklists. When solved, check the box and explain the answer.

## Learning
_Describe the research stage_

_Links to blog posts, patterns, libraries or addons used to solve this problem_

## Issue Number
specify (if any) the issue number this pull request belongs to.

#### Blog Posts
- [How to Pull Request](https://github.com/flexyford/pull-request) Github Repo with Learning focused Pull Request Template.
